/*

Commande de deux servomoteurs à l'aide d'une télécommande IR
-------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////////////
///   Ce programme concernenles télécommande affichant un code différent aprés chaque //
///   nouvel appui sur une touche                                                     //
////////////////////////////////////////////////////////////////////////////////////////

destinés à l'orientation Pan/Tilt d'une camera.
ATTENTION: La vitesse de déplacement est limitée par la durée des trames IR.  10 s environ pour 90° 
Pan =  Panoramique.
Tilt = Inclinaison.
Inversez les fils de commande des servo moteurs si nécessaire (Pin 9 et 10).
Utiliser de préference une télécommande munie de flèches de direction.
Les codes sont à modifier selon la télécommande  et les boutons choisis.
Pour cela, après avoir branché la diode IR sur le module Arduino comme spécifié 
(sortie données Pin D11 ) utiliser le programme "CodeTele" joint au fichier.

////////////////////////////////////////////////////////////////////////////////////////
///   Ce programme concernenles télécommande affichant un code différent aprés chaque //
///   nouvel appui sur une touche                                                     //
////////////////////////////////////////////////////////////////////////////////////////

La vitesse de déplacement est limitée par la durée des trames IR.  10 s environ pour 90° 

Le bouton "Enter" replace la camera dans une position prédéterminée (ici x 90° / y 90°)

F5MNA  Mars 2013  ( Mon site http://f5mna.free.fr )
*/

#include <IRremote.h>
#include <Servo.h>;  //inclu Servo.h 

Servo Pan;           //Déclaration des servos Pan et Tilt
Servo Tilt;

int RECV_PIN = 11;   //Pin 11 reception données IR
IRrecv irrecv(RECV_PIN);
decode_results results;

char TOP;
int Led = 13;     //LED
int valT, valP;   //Valeurs envoyée aux servomoteurs
int Pos;          // Positions haut, bas, droite, gauche, stop
 
void setup()
{
  Pan.attach(9);     //assigne pin 9 et 10 pour le signal de sortie destiné à commander les servos
  Tilt.attach(10);
 
  Serial.begin(9600);
  irrecv.enableIRIn(); // Démarrage du récepteur
  pinMode(Led, OUTPUT);
  Pos = 0;
  valT = 90;
  valP = 90;
  Serial.println (" Camera Pan/Tilt F5MNA");
  Serial.println ("Reception des valeurs X Y");
  Serial.println (" ");
}

void loop() {
  if (irrecv.decode(&results)) {  // Si un signal est reçu...
    irrecv.resume(); // En attente de la prochaine valeur
    TOP = (results.value);
    
  switch (TOP)
     {
  //Haut  Valeur 1
  case 83621895: 
     Pos = 1;
  break; 
    //Haut Valeur 2
  case 83621875: 
     Pos = 1;
  break;   
    
  // Bas Valeur 1
  case 83585175: 
     Pos = 2;  
  break; 
  
  // Bas Valeur 2
  case 83588175: 
     Pos = 2;  
  break; 

  //Gauche Valeur 1
    case 83613735:
     Pos = 3; 
  break; 
  
  //Gauche Valeur 2
    case 83618735:
     Pos = 3; 
  break; 
  
  // Droite   Valeur 1
   case 83601495:
    Pos = 4; 
  break; 
 
   // Droite Valeur 2
   case 83681495:
    Pos = 4; 
  break;  
 
 // Retour préposition Valeur 1
   case 83593335:
     Pos = 0;     
   break; 
   
 // Retour préposition Valeur 2
   case 83598335:
     Pos = 0;     
   break;  
 
    //A allumé  
  case 83895975:   
        digitalWrite(Led, HIGH);
        Serial.println ("Allume");            
  break; 
  
  //E eteint 
     case 83597455 :
        digitalWrite(Led, LOW);
        Serial.println ("Eteint");            
  break; 

        }
  //}
 
 switch (Pos)
  {
  case 1: //Haut
     if (valT < 170)  (valT = valT ++) ;
     break; 
  
  case 2: //Bas
     if (valT > 10) (valT = valT --) ;  
     break; 
 
  case 3: //Droite
     if (valP < 170)  (valP = valP ++) ; 
     break; 
  
  case 4: //Gauche 
     if (valP > 10) (valP = valP -- ); 
  break; 
  
  case 0: //Retour position prédéfinie (90 90)

  if (valP != 90) {
  if (valP < 90) {
    valP ++ ;
  }
    if (valP > 90) {
    valP -- ;
  }
  }  
  if (valT != 90)  {
    if (valT < 90) {
    valT ++ ;
  }
    if (valT > 90) {
    valT -- ;
  }
  } 
 } 
  Serial.print ("   X: ");
  Serial.print (valP);
  Serial.print ("   Y: ");
  Serial.println (valT);
 
  Pan.write(valP);                          //Donne au servo Pan la valeur en degrés à atteindre
  Tilt.write(valT); 

}
}
